package hitesh.androidjsonapp;


import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.os.StrictMode;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by abc on 26-Jun-15.
 */
public class JSONActivity extends ActionBarActivity {

    private Context context;
    private static String url = "http://www.parallelcodes.com/wp-content/uploads/2015/06/movies2.txt";
    TextView lblinfo;
    ArrayList<HashMap<String, String>> jsonlist = new ArrayList<HashMap<String, String>>();
    ListView list;
    Button btn;
    List<Map<String, String>> moviedata;
    ConnectivityManager cm;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.js);
        StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
        StrictMode.setThreadPolicy(policy);
        lblinfo = (TextView) findViewById(R.id.lblinfo);
        lblinfo.setText("JSON from HTTP File");
        list = (ListView) findViewById(R.id.list);
        btn = (Button) findViewById(R.id.btnparse);
        moviedata = new ArrayList<Map<String, String>>();

        btn.setOnClickListener(new View.OnClickListener() {

                                   @Override
                                   public void onClick(View v) {
                                       cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
                                       NetworkInfo activeNetworkInfo = cm.getActiveNetworkInfo();
                                       if (activeNetworkInfo != null)
                                           Parser();
                                       else {
                                           Toast.makeText(JSONActivity.this, "No Internet connectivity. Please Check your Internet Connection.", Toast.LENGTH_LONG).show();
                                       }
                                   }
                               }
        );
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();
        if (id == R.id.otheractivity) {
            Intent i = new Intent(JSONActivity.this, JSONActivityLocal.class);
            startActivity(i);
            finish();
            return true;
        }

        return super.onOptionsItemSelected(item);
    }


    public void Parser() {
        JSONParser jParser = new JSONParser(); // get JSON data from URL
        JSONArray json = jParser.getFromURL(url);
        int j = json.length();
        try {

            for (int i = 0; i < j; i++) {
                Map<String, String> moviemap = new HashMap<String, String>();
                JSONObject jsonChildNode = json.getJSONObject(i);

                String movie = jsonChildNode.optString("Movie").toString();
                String category = jsonChildNode.optString("Category").toString();

                moviemap.put("A", movie);
                moviemap.put("B", category);

                moviedata.add(moviemap);
            }
            String[] from = {"A", "B"};
            int[] views = {R.id.lblmoviename, R.id.lblcategory};
            final SimpleAdapter myadapter = new SimpleAdapter(JSONActivity.this, moviedata, R.layout.jslist, from, views);
            list.setAdapter(myadapter);
            Toast.makeText(JSONActivity.this, "Data fetched from " + url, Toast.LENGTH_LONG).show();

        } catch (JSONException e) {
            Toast.makeText(JSONActivity.this, e.getMessage().toString(), Toast.LENGTH_LONG).show();
        }

    }
}